#****************************************************************************
#**
#**  File     :  /lua/unit.lua
#**
#**  Author(s):  Resin_Smoker
#**
#**  Copyright  20 Feb 2010
#****************************************************************************

do
local oldUnit = Unit
Unit = Class(oldUnit) {
    
    ##########################################################################################
    ## SHIELD Scripts required for Projected Shields, Author:  Resin_Smoker
    ##########################################################################################  
    SpawnProjectedShield = function(self, Parent, OverKill, Impact, RegenDelay) 
             
        if not self:IsDead() then 
                               
            ### Get unit bp and Initialize variables
            local bp = self:GetBlueprint() 
            local bpDisplay = bp.Display            
            local sldHealth, rChgTime                          
            
            ### Sets the shield hitpoints by tech level 
            if table.find(bp.Categories ,'EXPERIMENTAL') then 
                if self:GetMaxHealth() * 0.1 >= 1000 then 
                    sldHealth = self:GetMaxHealth() * 0.1                   
                else
                    sldHealth = 5000
                end
                rChgTime = 60               
            elseif table.find(bp.Categories ,'TECH3') then 
                sldHealth = self:GetMaxHealth() * 0.2  
                rChgTime = 30                                                  
            elseif table.find(bp.Categories ,'TECH2') then 
                sldHealth = self:GetMaxHealth() * 0.3
                rChgTime = 15                                                         
            else
                sldHealth = self:GetMaxHealth() * 0.4
                rChgTime = 5        
            end           
                                                                                
            ### Remove the old shield if any 
            if self.MyShield then
                self:DestroyShield()                                            
            end 
            
            ### Get the units mesh information                                                                   
            self.MyShield = UnitShield {
                Owner = self,
                ParentSPU = Parent or self,
                ImpactEffects = Impact or 'AeonShieldHit01',                     
                CollisionSizeX = bp.SizeX * 0.55 or 1,
                CollisionSizeY = bp.SizeY * 0.55 or 1,
                CollisionSizeZ = bp.SizeZ * 0.55 or 1,
                CollisionCenterX = bp.CollisionOffsetX or 0,
                CollisionCenterY = bp.CollisionOffsetY or 0,
                CollisionCenterZ = bp.CollisionOffsetZ or 0,
                OwnerShieldMesh = bpDisplay.PShieldMeshBlueprint,
                ShieldMaxHealth = sldHealth,
                ShieldRechargeTime = rChgTime or 1,
                ShieldEnergyDrainRechargeTime = 5,
                ShieldRegenRate = sldHealth * 0.025,
                ShieldRegenStartTime = RegenDelay or 1,
                PassOverkillDamage = OverKill or false, 
            }                                              
                                                      
            ### Activate the personal shield
            self:SetFocusEntity(self.MyShield)
            self:EnableShield()
            self.Trash:Add(self.MyShield)  
        end              
    end,        
    ####################################
    ### End of Projected Shields scripts
    ####################################
}
end